#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <unistd.h>

#define PUERTO 2200
#define TAM_MSG 1000
#define TAM_NICK 20
#define MAX_CLIENTES 50

int main()
{
	int sfd, cfd, cc=0;
	int clientes[MAX_CLIENTES];
	char nicks[MAX_CLIENTES][TAM_NICK], naux[TAM_NICK];
	char users[MAX_CLIENTES][TAM_NICK];
	int clilen;
	struct sockaddr_in dirclient, dirserver;
	fd_set rset, allset;
	int maxfd, neventos;
	int i, j, flu, n;
	char comando[10];
	char msg[TAM_MSG], msg2[TAM_MSG], lu[TAM_MSG];
	int tam;
	int mode;
	


	FILE *pf;
	long cl,l,b;
	char matrix[32][250];
	char cama;




	sfd=socket(AF_INET, SOCK_STREAM, 0);
	bzero(&dirserver, sizeof(dirserver));
	dirserver.sin_family=AF_INET;
	dirserver.sin_port=htons(PUERTO);
	dirserver.sin_addr.s_addr=htonl(INADDR_ANY);
	
	bind(sfd, (struct sockaddr *) &dirserver, sizeof(dirserver));

	listen(sfd, MAX_CLIENTES);
	
	
	mode=1;
	setsockopt(sfd, SOL_SOCKET, SO_REUSEADDR,
		       (const char*)&mode, sizeof(mode));
		       	
	// vacio el conjunto de descriptores
	FD_ZERO(&rset);
	FD_ZERO(&allset);
	
	// Añado el socket
	FD_SET(sfd, &allset);
	
	maxfd=sfd;
	
	// inicializamos el array de los descriptores
	// de clientes
	for (i=0; i<MAX_CLIENTES; i++) {
		clientes[i]=-1;
	}

	for (;;) {
		// monto el select
		printf("Voy a hacer un select, Espero un evento\n");
		rset=allset;
		if (FD_ISSET(4, &rset)) {
			printf("Fdset Tipo 4 \n");
		}
		neventos=select(maxfd+1, &rset, NULL, NULL, NULL);
		if (neventos<=0) {
			continue;
		}
		// Se han producido eventos
		printf("Se han producido %d eventos, ", neventos);

		// será el socket del servidor?
		if (FD_ISSET(sfd, &rset)) {
			clilen=sizeof(dirclient);
			cfd=accept(sfd, (struct sockaddr *) &dirserver, &clilen);
			
			printf("Se ha conectado un nuevo cliente\n");
		
			// aceptamos el cliente y buscamos una posición libre
			for (i=0; i<MAX_CLIENTES; i++) {
				if (clientes[i]==-1) {
					break;
				}
			}
			FD_SET(cfd, &allset);
			if (FD_ISSET(cfd, &allset)) {
				printf("Se a~ade fd=%d al conjunto, ", cfd);
			}
			if (cfd>maxfd) {
				maxfd=cfd;
			}
			clientes[i]=cfd;
			
			// Leo el nick
			bzero(nicks[i],TAM_NICK);
			read(cfd, nicks[i], TAM_NICK);
			printf("Conectado nick: %s\n", nicks[i]);
											
				sprintf(msg2,"%s llega a la sala. ", nicks[i]);
				    printf("Enviando mensaje %s\n", msg2);
				    for (j=0; j<MAX_CLIENTES; j++) {
					if (clientes[j]==-1) {
						continue;
				        } else if (clientes[j]==clientes[i]) {
						continue; // mismo cliente
					}
					write(clientes[j], msg2, strlen(msg2));
				    }
			
			neventos--;
			if (neventos==0) {
			//	printf("continue\n");
				continue;
			}
		}
		printf("Quedan %d eventos\n", neventos);
		// Si llego por aquí voy a estudiar
		// el tratamiento de los clientes
		for (i=0; i<MAX_CLIENTES; i++) {
			printf("%d\t", i);
			if (clientes[i]==-1) {
				continue;	
			} else if (!FD_ISSET(clientes[i], &rset)) {
				continue;
			}
			printf("%d produce evento, ", i);
			// si llego aquí el cliente i produce evento
			// leo del socket
			bzero(msg, TAM_MSG);
			tam=read(clientes[i], msg, TAM_MSG);
			printf("de %s con texto: %s\n", nicks[i], msg);
			if (tam==0) {
				// El cliente cierra la conexión
				
				for (j=0;j<cc;j++){
				
				    if (strcmp(nicks[i], users[j])==0){
				        for (n=0;n<TAM_NICK;n++){
						users[j][n]=users[cc-1][n];}
					         
				    }
				}				
				
				
				cc--;
				printf("DEBUG i=%d j=%d e=%d m1=%s m2=%s",i,j,neventos,nicks[i],msg2);
				printf("%s Cierra la conexion.\n", nicks[i]);
				close(clientes[i]);
				FD_CLR(clientes[i], &allset);
				clientes[i]=-1;
				printf("DEBUG i=%d j=%d e=%d m1=%s m2=%s",i,j,neventos,nicks[i],msg2);

				
				
				
								    
				//ennvio msg
				sprintf(msg2,"%s Cierra sesion ", nicks[i]);
				    printf("Enviando mensaje AKI -> %s", msg2);
				    printf("DEBUG i=%d j=%d e=%d m1=%s m2=%s",i,j,neventos,msg,msg2);
				    
				
				    
				    for (j=0; j<MAX_CLIENTES; j++) {
					if (clientes[j]==-1) {
						continue;
				        } 
				        
				        else if (clientes[j]==clientes[i]) {
						continue; // mismo cliente
					}
						if ( strlen(msg2) != 0) {
						write(clientes[j], msg2, strlen(msg2));
						}
				    }


                                   


			} else {





				// recibimos un mensaje
				// y lo enviamos a todos los usuarios
				// menos al que lo envia
				bzero(comando,10);
				for (j=0; j<5; j++){
				comando[j]=msg[j];
			    	}
				printf("comando = %s",comando);
			     if ((strcmp(comando, "*list"))==0) {
				    bzero(lu, TAM_MSG);
				    sprintf(lu,  "*/listado: ");
				    
				    flu=0;
				    for (j=0; j<cc ; j++){
					sprintf(naux,"%s, ",users[j]);
					sprintf(lu,"%s %s", lu, naux);
				     	}
	                            flu=strlen(lu);
				    			
	
				    write(clientes[i], lu , flu);
        			    printf("ENV. lista Usarios a %s \n", nicks[i] );
								    	
			        
				}else {
					//printf("Formando mensaje\n");
				    sprintf(msg2, "%s : %s", nicks[i], msg);
				    printf("Enviando mensaje %s\n", msg2);
				    for (j=0; j<MAX_CLIENTES; j++) {
					if (clientes[j]==-1) {
						continue;
				        } else if (clientes[j]==clientes[i]) {
						continue; // mismo cliente
					}
					write(clientes[j], msg2, strlen(msg2));
				    }
				}	    	    
			}
			neventos--;
			if (neventos==0) {
				break;
			}
		}
	}
	close(sfd);
	exit(0);
}

