<?php
/**
* css=html captcha class
* @version 1.1
* @autor: Arthuro Mazoli: info@brixtone.nl
* december 2006
* this is htmlcaptcha light; the free version
* see also our full-version; 
* it only costs you 50 dollar, and helps us to develop other nice software
* http://www.htmlcaptcha.org
*/

class csscaptcha {
	
	var $keydir = 'htmlcaptcha/keys/';
	
	/**
	 * the characters fot the encryptionkey
	 */
	var $keychars =  Array('a','b','c','d','e','f','g','h','j','i','k','l','m','n','o','p','Q','r','s','t','u','v','w','x','y','1','3', '5','7','9','0');
	
	/**
	 * the function witch draws the html;
	 */
	function draw ($text='captcha text') {
		
		include(dirname(__FILE__).'/verdana.php');
		
		$captcha ='';
		$retVal = '';
		
		$retVal = $this->css();
		$retVal .= "<div id=csscaptcha>\n";
		
		for ($a=0;$a<5;$a++) {
			
			$raster = array();

			$_l = $letter[rand(0,(count($letter)-1))];
			$_letter =  $_l[1];
			$captcha .= $_l[0];

			$retVal .=  "<div class=letter style=\"border-color:silver;background-color:#e3e3e3\">\n";
			foreach($_letter as $k=>$v) {
				$val = explode('.',$v);
				$raster[$val[0]][ $val[1] ] = true;
			}
			
			$rastersize = count($raster);
			for ($i=0;$i<$rastersize;$i++) {
				
				$retVal .=  "<div>\n";
				for ($j=0;$j<$rastersize;$j++) {

					if ($raster[$i][$j]===true)
						$retVal .= "<span class=\"a\" style=\"color:#474747\"></span>\n";
					else 
						$retVal .=  "<span></span>\n";
				}
				$retVal .=  "</div>\n";
			}
			$retVal .=  "</div>\n";
		}
		$this -> clearOldFiles ();
		$retVal .=  "</div>";
		$md5 = $this -> createMD5 ( $this -> createKey(), $captcha);
		$retVal .=  "<div class=htmlcapcha_label><input type=hidden name=htmlcaptchakey value=$md5>";
		$retVal .=  "<label>$text</label><br><input type=text name=htmlcaptchatext></div>";
		
		return $retVal;
	}
	
	/**
	* create the private key
	*/
	function createKey () {
		$k ='';
		for ($a=0;$a<$this->key;$a++) 
			$k .= $this->keychars[rand(0,(count($this->keychars)-1))];
		
		return $k;
	}
	
	/**
	* create the public md5 string witch is the cached filename and  is send to the client
	*/
	function createMD5 ($key, $captcha) {
		$md5 = md5($key.$captcha);
		$this->save_file($this->keydir.$md5.'.php', "<?PHP//###$key###?>");
		return $md5;
	}
	
	/**
	* file save function
	*/
	function save_file ($path, $tmpStr) {
		$path_parts  = pathinfo($path);
		if (is_writable($path_parts['dirname'])) {
			$fp = fopen ($path, 'w');
			fputs($fp, $tmpStr);
			fclose ($fp);
			return true;
		} else {
			print "<br><strong>HtmlCaptcha error</strong>. The directory /" .  $path_parts['dirname'] ."/ is not writable.<br>Please change the rights of this dir with the CHMOD command or contact your server administrator.<br>";
			return false;
		}
	}
	/**
	* get the file content
	*/
	function get_File ($myFile, $toString=true) {
		$inString = false;
		$fileContentArr=false;
		if (@is_file($myFile)){
			if (@is_readable ($myFile)){
				$fileContentArr = file($myFile);
				if ($toString==true)
					$inString = implode('', $fileContentArr);
				else 
					$inString = $fileContentArr;
			}
		} 
		return $inString;
	}
	
	/*
	* trash all key-file older then $lifetime minutes
	* default: 10 minutes
	*/
	function clearOldFiles() {
		
		@$dir = opendir($this->keydir);
		
		if(!$dir) 
			exit('<br><strong>HtmlCaptcha error</strong>: the directory of the temporary-keys  ('.$this->keydir.') does not excists.<br>Please add this directory (be sure to make it writabel for the HtmlCaptcha application) or contact your server administrator.<br>'); 
		
			
		$t = time() - (10 * 60);
		$comparedate = date('YmdHis', $t);
		
       	while($entry = readdir($dir)){
        	if($entry != ".." && $entry != ".") {
                $fulldir=$this->keydir.$entry;
				$last_modified= date("YmdHis", filemtime($fulldir));
				if ($comparedate > $last_modified)  {
//					print "DELETE: " . $fulldir. "<br>";
					@unlink($fulldir);
				} else {
//					print "OK: " .  $fulldir . "<br>";
				}
			}
		}
	}
	
	/**
	* check the captcha after posting the captcha text by the user
	*
	*/
	function checkCaptcha () {
		/* backwards compatible problem*/
		if (isset( $GLOBALS['_POST'] )) $GLOBALS['HTTP_POST_VARS'] = $GLOBALS['_POST'];
		if (isset( $GLOBALS['_GET'] )) $GLOBALS['HTTP_GET_VARS'] = $GLOBALS['_GET'];
		/* backwards compatible problem*/
		
		if ($GLOBALS['HTTP_POST_VARS'])
			$args = $GLOBALS['HTTP_POST_VARS'];
		else
			$args = $GLOBALS['HTTP_GET_VARS'];
		
		$md5 = $args['htmlcaptchakey'];
		$captcha =$args['htmlcaptchatext'];
		
		$key = $this->get_File ($this->keydir.$md5.'.php');
		$orgKey = $key;
		
		if ($key) {
			$k = explode('###', $key);
			$key = $k[1];
		}
		//check on DOS attack: more the 10 times  the same captcha....
		if (count($k)>10) {
			header ("location: http://www.google.com");
		}

		if (md5($key.$captcha) == $md5) {
			@unlink($this->keydir.$md5.'.php');
			return true;
		} else {
			$this->save_file ($this->keydir.$md5.'.php', preg_replace("/\?\>/",'',$orgKey)."next###?>");
			return false;
		}
	}
	
	function css() {
		
		return "<style>#csscaptcha {
		width:100%;
		overflow:auto;
	}
	.csscaptchaBig {
		width:23em !important;
		position:absolute;
	}
	
	#csscaptcha .letter {
		float:left;
		background-color:white;
		margin-right:0.2em;
		width:2.1em;
		height:1.9em;
		position:relative;
		border:0.2em black solid;
		-moz-box-sizing : border-box;
	}
	#csscaptcha .letter DIV {
		width:100%;
		overflow:auto;
		position:relative;
	}
	#csscaptcha .letter SPAN {
		width:0.2em;
		height:0.2em;
		float:left;
		margin:0px;
		line-height:0.1em;
		overflow:hidden;
		position:relative;
	}
	#csscaptcha .letter .a {
		background:black;
	}
	/*bigletter*/
	#csscaptcha .bigletter {
		float:left;
		background-color:white;
		margin-right:0.3em;
		width:3.8em;
		height:3.6em;
		position:relative;
		border:0.4em black solid;
		-moz-box-sizing : border-box;
	}
	#csscaptcha .bigletter DIV {
		width:100%;
		overflow:auto;
		position:relative;
	}
	#csscaptcha .bigletter SPAN {
		width:0.4em;
		height:0.4em;
		float:left;
		margin:0px;
		line-height:0.1em;
		overflow:hidden;
		position:relative;
	}
	#csscaptcha .bigletter .a {
		background:black;
	}
	.csscaptchaplus {
		border:1px black solid;
		width:0.7em;
		cursor:hand;
		cursor:pointer;
		font-weight:bold;
		-moz-box-sizing : border-box;
		float:left;
		line-height:0.5em;
		margin-top:0.5em;
		margin-left:-0.2em
		
	}
	.csscaptchahidden {
		position:absolute;
		z-index:2;
		top:0px;
		left:0px;
	}
	.htmlcapcha_label {
		overflow:auto;
		width:100%;
		font-family:arial;
		font-size:0.9em;
		color:black;
	}</style>";
	}
}
?>